<template>
  <b-container v-if="showPage == true">
    <div class="row no-gutters mb-5">
      <div class="col-md-5">
        <div class="position-absolute p-2">
          <span class="badge badge-danger" v-if="typeChamps['switch'][2].value">Promo</span>
          <span class="badge badge-warning" v-if="typeChamps['switch'][3].value">Nouveauté</span>
          <span class="badge badge-success" v-if="typeChamps['switch'][4].value">Top vente</span>
        </div>

        <CoolLightBox :items="itemsLightbox" :index="index" @close="index = null" :fullScreen="true" :useZoomBar="true"></CoolLightBox>

        <div v-if="isCarousel === 'false'" class="images-wrapper">
          <div class="img-box-1" @click="index = 0" :style="{ backgroundImage: 'url(' + urlFTP + 'tn/tn1-' + typeChamps['image'][0].value + ')' }"></div>

          <div class="thumbs-wrapper row no-gutters mt-3 mb-4">
            <div class="img-box-2 col-6 col-sm-4 col-lg-3 mb-1" v-for="(image, indice) in typeChamps['image']" :key="image.id" @click="index = indice" :style="{ backgroundImage: 'url(' + urlFTP + 'tn/tn3-' + image.value + ')' }"></div>
          </div>
        </div>

        <!-- Option diapo carousel -->
        <b-carousel v-if="isCarousel === 'true'" id="carousel-1" :interval="4000" controls indicators background="transparent" img-width="800" img-height="600" style="text-shadow: 1px 1px 2px #333" @sliding-start="onSlideStart" @sliding-end="onSlideEnd">
          <!-- Text slides with image -->
          <b-carousel-slide :img-src="urlFTP + 'tn/tn2-' + image.value" v-for="image in typeChamps['image']" :key="image.id"></b-carousel-slide>
        </b-carousel>
        <!-- /Option diapo carousel -->
      </div>

      <div class="col-md-7 p-5">
        <div class="card-body">
          <h1 class="h2" v-if="typeChamps['titre'][1].value != ''">{{ typeChamps["titre"][1].value }}</h1>
          <h2 class="h5 card-title" v-if="typeChamps['titre'][2].value != ''">{{ typeChamps["titre"][2].value }}</h2>
          <p class="card-text">
            <small class="text-muted" v-if="typeChamps['titre'][0].value != ''">{{ typeChamps["titre"][0].value }}</small>
          </p>
          <p class="card-text mb-4" v-if="typeChamps['description'][1].value">
            {{ typeChamps["description"][1].value }}
          </p>

          <!-- Déclinaisons dans un tableau -->
          <div v-if="declinaisonRender === 'tableau'">
            <table class="table" v-if="champsPrix.typePrix == 'declinaisons'">
              <thead>
                <tr>
                  <!-- <th scope="col">#</th> -->
                  <th scope="col" v-for="headerV in filteredModule[0].declinaisons" :key="headerV.id">{{ headerV }}</th>

                  <th scope="col"></th>
                  <th scope="col"></th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="variant in variantsOriginal" :key="variant.id">
                  <!-- <th scope="row">{{ variant.id }}</th> -->
                  <td v-for="n in typeChamps['headerProperties'].length" :key="n.id">
                    {{ variant.properties[n - 1] }}
                  </td>
                  <td>
                    <!-- Prix liste déclinaisons -->
                    <!-- prix1 > prix2 -->
                    <small v-if="variant.prices[0] > variant.prices[1] && variant.prices[1] > 0"
                      ><del>Prix : {{ variant.prices[0] | euro }}</del></small
                    >
                    &nbsp;
                    <strong v-if="variant.prices[0] > variant.prices[1] && variant.prices[1] > 0">Promo : {{ variant.prices[1] | euro }}</strong>
                    <!-- prix1 > prix2 -->
                    <small v-if="variant.prices[1] > variant.prices[0] && variant.prices[0] > 0"
                      ><del>Prix : {{ variant.prices[1] | euro }}</del></small
                    >
                    &nbsp;
                    <strong v-if="variant.prices[1] > variant.prices[0] && variant.prices[0] > 0">Promo : {{ variant.prices[0] | euro }}</strong>

                    <!-- prix1 > 0 -->
                    <strong v-if="variant.prices.length == 1 && variant.prices[0] > 0">Prix : {{ variant.prices[0] | euro }}</strong>

                    <strong v-else-if="variant.prices[0] > variant.prices[1] && variant.prices[1] == 0">Prix : {{ variant.prices[0] | euro }}</strong>

                    <!-- prix2 > 0 -->
                    <strong v-if="variant.prices[1] > variant.prices[0] && variant.prices[0] == 0">Prix : {{ variant.prices[1] | euro }}</strong>
                  </td>
                  <td>
                    <b-button size="sm" :disabled="variant.quantite < 1" @click="addToCart(moduleContent, variant)">Ajouter au panier</b-button>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>

          <div class="mb-4">
            <!-- Liens -->
            <a class="btn btn-default mb-1" target="_blank" :href="correctUrl(typeChamps['titre'][3].value)" v-if="typeChamps['titre'][3].value"><b-icon icon="link45deg"></b-icon> {{ typeChamps["titre"][3].libelle }}</a>
            <a class="btn btn-success mb-1" target="_blank" :href="correctUrl(typeChamps['titre'][4].value)" v-if="typeChamps['titre'][4].value"><b-icon icon="link45deg"></b-icon> {{ typeChamps["titre"][4].libelle }}</a>

            <!-- Pdfs -->
            <a class="btn btn-danger mb-1" :href="urlFTP + 'pdf/' + pdf.value" v-for="pdf in typeChamps['pdf']" :key="pdf.id"><b-icon icon="file-earmark-arrow-down"></b-icon> {{ pdf.libelle }}</a>
          </div>

          <div class="mb-4">
            <a class="btn btn-default mb-1" href="#">Imprimer </a>
            <a class="btn btn-success mb-1" @click="$bvModal.show('modal-ami')" v-if="typeChamps['switch'][0].value">Recommander à un ami</a>
          </div>

          <!-- Modal pour recommander à un ami -->
          <b-modal id="modal-ami" ref="modal-ami" title="Pour partager ce produit avec votre ami(e), remplissez le formulaire ci-dessous." @show="resetModal" @hidden="resetModal" hide-footer>
            <!--<form ref="form" @submit.stop.prevent="handleSubmit">
              <b-form-group id="input-group-2" label="Offert par:" label-for="input-1">
                <b-form-input id="input-1" v-model="form2.name" required placeholder="Nom Prénom"></b-form-input>
              </b-form-group>

              <b-form-group id="input-group-2" label="Email de votre ami(e):" label-for="input-4">
                <b-form-input id="input-4" v-model="form2.email" type="email" required placeholder="Email de votre ami(e)"></b-form-input>
              </b-form-group>

              <b-form-group id="input-group-2" label="Message:" label-for="input-4">
                <b-form-textarea id="textarea" v-model="form2.text" placeholder="Votre texte d'accompagnement" rows="3" max-rows="6"></b-form-textarea>
              </b-form-group>

              <b-button type="submit" variant="success">Envoyer</b-button>
              <b-button type="reset" variant="danger" @click="$bvModal.hide('modal-ami')">Annuler</b-button>
            </form>-->
            <recommendation/>
            <b-button type="reset" variant="danger" @click="$bvModal.hide('modal-ami')">Fermer</b-button>
          </b-modal>

          <!-- Fin modal recommander à un ami -->

          <!-- Déclinaisons select -->
          <div v-if="declinaisonRender === 'select'">
            <form class="form mb-3">
              <div class="row mb-1">
                <div class="form-group col-md-4" v-for="(property, index) in typeChamps['headerProperties']" :key="property.id">
                  <label for v-if="filteredVariantsData[index]">
                    <strong>{{ property }}</strong>
                  </label>
                  <select
                    class="custom-select my-1 mr-sm-2"
                    :id="'inlineFormCustomSelectPref' + index"
                    @change="changeVariant2(index)"
                    v-model="variantsChoices[index][0]"
                    v-if="filteredVariantsData[index] && filteredVariantsData[index].length > 0"
                    :disabled="!variantsChoices[index][0] == ''"
                  >
                    <option value="">Choix {{ property }}</option>
                    <option v-for="variant in filteredVariantsData[index]" :key="variant.id" :value="variant">{{ variant }}</option>
                  </select>
                </div>
                <b-button v-if="variantsChoices[0][0] !== '' && declinaisonRender === 'select'" @click="resetSelect()"><font-awesome-icon icon="undo"/></b-button>
              </div>
            </form>
          </div>

          <form class="form mb-3">
            <div>
              <b-form-spinbutton id="sb-inline" v-model="qte" inline></b-form-spinbutton>
            </div>
          </form>

          <!-- ## Gestion des prix simples ## -->
          <!-- if prix1 > prix 2 -->
          <div class="card h4" v-if="typeChamps['prix']">
            <div class="card-body" v-if="typeChamps['prix'][0].value > typeChamps['prix'][1].value">
              <small
                ><del>Prix : {{ typeChamps["prix"][0].value | euro }}</del></small
              >
              &nbsp;
              <strong>Promo : {{ typeChamps["prix"][1].value | euro }}</strong>
            </div>

            <!-- if prix2 > prix 1 -->
            <div class="card-body" v-if="typeChamps['prix'][1].value > typeChamps['prix'][0].value">
              <small
                ><del>Prix : {{ typeChamps["prix"][1].value | euro }}</del></small
              >
              &nbsp;
              <strong>Promo : {{ typeChamps["prix"][0].value | euro }}</strong>
            </div>

            <!-- if prix1 > 0 -->
            <div class="card-body" v-if="typeChamps['prix'][0].value > 0 && typeChamps['prix'][1].value == 0">
              <strong>Prix : {{ typeChamps["prix"][0].value | euro }}</strong>
            </div>

            <!-- if prix2 > 0 -->
            <div class="card-body" v-if="typeChamps['prix'][1].value > 0 && typeChamps['prix'][0].value == 0">
              <strong>Prix : {{ typeChamps["prix"][1].value | euro }}</strong>
            </div>
          </div>
          <!-- ## Fin prix simple ##-->

          <!-- ## Gestion des Prix déclinaisons ## -->
          <!-- if prix1 > prix 2 -->
          <div class="card h4" v-if="selectedVariant.length > 0 && selectedVariant[0].prices.length > 0">
            <div class="card-body" v-if="selectedVariant[0].prices[0] > selectedVariant[0].prices[1] && selectedVariant[0].prices[1] > 0">
              <small
                ><del>Prix : {{ selectedVariant[0].prices[0] | euro }}</del></small
              >
              &nbsp;
              <strong>Promo : {{ selectedVariant[0].prices[1] | euro }}</strong>
            </div>

            <!-- if prix2 > prix 1 -->
            <div class="card-body" v-if="selectedVariant[0].prices[1] > selectedVariant[0].prices[0] && selectedVariant[0].prices[0] > 0">
              <small
                ><del>Prix : {{ selectedVariant[0].prices[1] | euro }}</del></small
              >
              &nbsp;
              <strong>Promo : {{ selectedVariant[0].prices[0] | euro }}</strong>
            </div>

            <!-- if prix1 > 0 -->
            <div class="card-body" v-if="selectedVariant[0].prices[0] > 0 && selectedVariant[0].prices[1] == 0">
              <strong>Prix : {{ selectedVariant[0].prices[0] | euro }}</strong>
            </div>

            <!-- if prix2 > 0 -->
            <div class="card-body" v-if="selectedVariant[0].prices[1] > 0 && selectedVariant[0].prices[0] == 0">
              <strong>Prix : {{ selectedVariant[0].prices[1] | euro }}</strong>
            </div>

            <div class="card-body" v-if="selectedVariant[0].prices.length == 1">
              <strong>Prix : {{ selectedVariant[0].prices[0] | euro }}</strong>
            </div>
          </div>

          <!-- ## Fin prix déclinaisons ## -->

          <div class="my-4">
            <a href="#" class="btn btn-lg btn-success mb-2" v-if="showAddCardBtn" @click="addToCart(moduleContent, selectedVariant[0])">Commander</a>

            <b-button id="show-btn" @click="$bvModal.show('modal-bon-cadeau')" class="btn btn-lg btn-info mb-2" v-if="typeChamps['switch'][1].value && isGiftCard === 'true'">Offrir un bon cadeau</b-button>

            <!-- Modal pour bon cadeau -->
            <!-- <b-button v-b-modal.modal-prevent-closing>Open Modal</b-button> -->
            <b-modal id="modal-bon-cadeau" ref="modal" title="Offrir un bon cadeau" @show="resetModal" @hidden="resetModal" @ok="handleOk" hide-footer>
              <form ref="form" @submit.stop.prevent="handleSubmit">
                <b-form-group id="input-group-2" label="Offert par:" label-for="input-1">
                  <b-form-input id="input-1" v-model="form.name" required placeholder="Nom Prénom"></b-form-input>
                </b-form-group>

                <b-form-group id="input-group-2" label="Prénom du bénéficiaire:" label-for="input-2">
                  <b-form-input id="input-2" v-model="form.name" required placeholder="Prénom"></b-form-input>
                </b-form-group>

                <b-form-group id="input-group-2" label="Nom du bénéficiaire:" label-for="input-3">
                  <b-form-input id="input-3" v-model="form.name" required placeholder="Nom"></b-form-input>
                </b-form-group>

                <b-form-group id="input-group-2" label="Email à qui envoyer le Bon Cadeau:" label-for="input-4">
                  <b-form-input id="input-4" v-model="form.email" type="email" required placeholder="Email du bénéficiaire"></b-form-input>
                </b-form-group>

                <b-form-group id="input-group-2" label="Message:" label-for="input-4">
                  <b-form-textarea id="textarea" v-model="form.text" placeholder="Votre texte d'accompagnement" rows="3" max-rows="6"></b-form-textarea>
                </b-form-group>

                <b-button type="submit" variant="success">Envoyer</b-button>
                <b-button type="reset" variant="danger" @click="$bvModal.hide('modal-bon-cadeau')">Annuler</b-button>
              </form>
            </b-modal>

            <!-- /Modal pour bon cadeau -->

            <router-link :to="'/contact'" v-if="isContactUs === 'true'" class="btn btn-lg btn-warning mb-2">Nous contacter</router-link>
          </div>

          <!-- Social -->
          <share-buttons :shareUrl="currentUrl" :shareTitle="typeChamps['titre'][1].value" :shareQuote="typeChamps['titre'][1].value" :shareDescription="typeChamps['description'][1].value" :sharePinterestMedia="urlFTP + 'compressed/' + typeChamps['image'][0].value"/>
          <ul class="list-unstyled list-inline list-social text-right mb-6 mb-md-0">
            <li class="list-inline-item list-social-item mr-3">
              <a href="#!" class="text-decoration-none">
                <img src="../../assets/img/icons/036-facebook.svg" width="25" alt="Facebook" />
              </a>
            </li>
            <li class="list-inline-item list-social-item mr-3">
              <a href="#!" class="text-decoration-none">
                <img src="../../assets/img/icons/008-twitter.svg" width="25" alt="Twitter" />
              </a>
            </li>
            <li class="list-inline-item list-social-item mr-3">
              <a href="#!" class="text-decoration-none">
                <img src="../../assets/img/icons/021-pinterest.svg" width="25" alt="Pinterest" />
              </a>
            </li>
            <li class="list-inline-item list-social-item mr-3">
              <a href="#!" class="text-decoration-none"><font-awesome-icon icon="share-alt" /> Partager</a>
            </li>
          </ul>

          <product-nav :champs="champs" :urlNameDetail="urlBack + '-detail'" :urlReturn="urlBack" :idFiche="idFiche" :moduleName="moduleName" v-if="champs && moduleName && idFiche" :listProducts="listProducts"> </product-nav>
        </div>
      </div>

      <b-modal id="addCart" :hide-footer="true" :hide-header="true" v-model="showModalAdd">Produit ajouté au panier</b-modal>
    </div>
  </b-container>
</template>

<script>
// ############ IMPORT MODULES ############ -->
import Vue from "vue";
import { mapState, mapActions } from "vuex";
import ProductNav from "../AppProductNav/productNav.vue";
import { cartService } from "@/_services/cart.service";
import moduleConfig from "@/config-data/config-products.json";
import ShareButtons from "../AppShareButtons/AppShareButtons";
import Recommendation from "./recommendation";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_DETAIL = URL_API + "api/popups/show/";
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";
const MODULENAME = "produits1";
export default {
  components: {
    Recommendation,
    ShareButtons,
    "product-nav": ProductNav
  },
  props: ["declinaisonRender", "isCarousel", "isGiftCard", "isContactUs"],
  computed: {
    // récupération infos client
    ...mapState({
      cartStore: state => state.cartStore
    })
  },
  beforeMount: function() {
    this.idFiche = this.$route.params.id;
    this.fetchDatas();
  },
  data() {
    return {
      // test
      tabIdx: [],
      initialList: [],
      urlFTP: process.env.VUE_APP_URL_UPLOAD_FOLDER + process.env.VUE_APP_SITE_ALIAS + "/",
      showModalAdd: false,
      currentUrl: window.location.href,
      //currentUrl: "https://vuejs.org/",
      showAddCardBtn: false,
      moduleConfig,

      // variables structure data
      champs: null,
      typeChamps: [],
      variantsChoices: [],
      variantsList: [],
      filteredVariantsList: [],
      variantsOriginal: [],
      filteredVariantsData: [],
      champsPrix: [],
      moduleContent: [],
      filteredModule: {},
      indexHeadersVariant: [],
      tabIndicesProp: [],
      selectedVariant: [],

      showPage: false,
      slide: 0,
      sliding: null,
      idFiche: null,
      itemsLightbox: [],
      index: null,
      imageIndex: 0,
      qte: 1,

      // modal
      name: "",
      nameState: null,
      submittedNames: [],
      // form test
      form: {
        email: "",
        name: "",
        text: "",
        food: null,
        checked: []
      },

      form2: {
        email: "",
        name: "",
        text: "",
        food: null,
        checked: []
      },

      show: true,
      //
      showNextBtn: true,
      showPrevBtn: true,
      nextId: null,
      prevId: null,
      urlBack: "notre-catalogue",
      moduleName: MODULENAME,
      listProducts: []
    };
  },
  methods: {
    fetchDatas() {
      this.$axios
        .get(URL_DATAS_DETAIL + this.idFiche)
        .then(response => {
          this.moduleContent = response.data.data;
          this.structureData();
        })
        .catch(error => {
          console.log("error", error);
        });
    },

    structureData() {
      // récupération de la config du module et des valeurs en bdd
      // pour creer un tableau des valeurs de la fiche associé à la config du module
      // sur lequel on peut itérer

      this.filteredModule = this.moduleConfig.filter(item => {
        return item.module === MODULENAME;
      });

      this.champs = JSON.parse(this.moduleContent.data);
      this.champsPrix = JSON.parse(this.moduleContent.dataprix);
      this.filteredModule[0].config.forEach(el => {
        // construction de la ligne
        let rawData = [];
        rawData.type = el.champs;
        rawData.value = this.champs[el.champs];
        rawData.libelle = el.libelle;
        // push de la ligne dans le tableau
        if (el.type == "liste") {
          rawData.items = el.items;
        }
        if (el.type in this.typeChamps) {
          this.typeChamps[el.type].push(rawData);
        } else {
          this.typeChamps[el.type] = [];
          this.typeChamps[el.type].push(rawData);
        }
      });

      // récupération config images
      this.typeChamps["image"] = [];
      this.filteredModule[0].medias.libellesImages.forEach((el, index) => {
        let rawData = [];
        rawData.type = "image" + parseInt(index + 1);
        rawData.value = this.champs["image" + parseInt(index + 1)];
        rawData.libelle = el;
        this.typeChamps["image"].push(rawData);
      });

      // intégration du tableau d'image dans le tableau pour le lightbox
      console.log("typeChamps", this.typeChamps);
      this.typeChamps["image"].forEach(img => {
        if (img.value.length > 0 && img.value !== "") {
          let rawImg = {
            title: "",
            description: "",
            src: this.urlFTP + "tn/tn1-" + img.value,
            thumb: this.urlFTP + "tn/tn1-" + img.value
          };
          this.itemsLightbox.push(rawImg);
        }
      });

      // suppression des lignes ne contenant pas d'images
      this.typeChamps["image"] = this.typeChamps["image"].filter(elem => {
        return elem.value !== "" && elem.value !== undefined && elem.value.length > 0;
      });

      // récupération config pdf

      this.typeChamps["pdf"] = [];
      this.filteredModule[0].medias.libellesPdf.forEach((el, index) => {
        let rawData = [];
        rawData.type = "pdf" + parseInt(index + 1);
        rawData.value = this.champs["pdf" + parseInt(index + 1)];
        rawData.libelle = el;
        this.typeChamps["pdf"].push(rawData);
      });

      // suppression des lignes ne contenant pas de pdf
      this.typeChamps["pdf"] = this.typeChamps["pdf"].filter(elem => {
        return elem.value !== null && elem.value !== "" && elem.value !== undefined && elem.value.length > 0;
      });

      // récupération config prix
      if (this.champsPrix.typePrix == "simple") {
        this.typeChamps["prix"] = [];
        if (this.filteredModule[0].prix.length > 0) {
          this.filteredModule[0].prix.forEach((el, index) => {
            let rawData = [];
            rawData.type = "prix" + parseInt(index + 1);
            rawData.value = this.champsPrix.simplePrice[index]["prix" + parseInt(index + 1)];
            rawData.libelle = el.libelle;
            this.typeChamps["prix"].push(rawData);
          });
        }
        this.showAddCardBtn = true;
      }

      // récupération config déclinaisons
      if (this.champsPrix.typePrix == "declinaisons") {
        this.structureVariants();
      }
      // this.checkPrevNext();

      // on récupère la liste des produits puis on l'enregistre pour passer au productnav
      if (this.$route.params.listProducts && this.$route.params.listProducts.length > 0) {
        this.listProducts = this.$route.params.listProducts;
      }

      this.showPage = true;
    },
    // Suppression doublons tableau / merci stackoverflow pour la fonction
    uniq(a) {
      return a.sort().filter(function(item, pos, ary) {
        return !pos || item !== ary[pos - 1];
      });
    },

    structureVariants() {
      // traitement headers tableau
      // console.log("this.declinaisons", this.filteredModule[0].declinaisons);

      // liste variantes
      this.typeChamps["headerProperties"] = [];
      let headerPropertes = [];
      let propertyList = this.champsPrix.selectedCombi.split(" >>> ");
      propertyList.forEach(property => {
        this.typeChamps["headerProperties"].push(property);
        this.variantsChoices.push([""]);
      });

      // liste prix
      this.typeChamps["headerPrices"] = [];
      this.filteredModule[0].prixDeclinaisons.forEach((el, index) => {
        let rawData = [];
        this.typeChamps["headerPrices"].push(el.libelle);
      });

      this.typeChamps["headerProperties"].forEach((prop, indexProp) => {
        this.variantsList.push([]);
        this.filteredVariantsList.push([]);

        this.champsPrix.declinaisons.forEach((elem, index) => {
          this.variantsList[indexProp].push(elem.properties[indexProp]);
          // traitement pour éviter les doublons
          this.variantsList[indexProp] = this.uniq(this.variantsList[indexProp]);
        });
      });
      // on initialise la premiere liste des variantes de la premiere déclinaison

      let initialIndex = 0;

      this.filteredModule[0].declinaisons.forEach((value, key) => {
        if (value === this.typeChamps["headerProperties"][0]) {
          initialIndex = key;
        }
      });

      this.filteredVariantsData[0] = this.variantsList[initialIndex];
      this.initialList = this.variantsList[initialIndex];
      // this.initialList = this.variantsList[initialIndex];
      this.variantsOriginal = this.champsPrix.declinaisons;
      this.filteredVariantsList = this.variantsOriginal;
      // console.log("variantsOriginal", this.variantsOriginal);

      // pouvoir faire la corrélation entre index dans properties et index typeChamps["headerProperties"] dans un tableau

      this.typeChamps["headerProperties"].forEach((valueHeader, keyHeader) => {
        let combi = [];

        this.filteredModule[0].declinaisons.forEach((valueDecli, keyDecli) => {
          if (valueHeader.toString() === valueDecli.toString()) {
            combi[valueHeader.toString()] = {
              indexHeaderV: keyHeader,
              indexDataV: keyDecli
            };
            this.tabIndicesProp.push(combi);
          } else {
            return;
          }
        });
      });
    },

    changeVariant2(indexSelect) {
      let nbOptions = this.typeChamps["headerProperties"].length;
      //reset des select si changement valeur select parent
      for (let i = 0; i < nbOptions; i++) {
        if (i > indexSelect) {
          this.filteredVariantsData.splice(i, 1);
          this.variantsChoices[i][0] = "";
        }
      }

      if (indexSelect + 1 < this.typeChamps["headerProperties"].length) {
        // on détermine l'id de l'option dans le json du produit
        let idx = this.tabIndicesProp[indexSelect][this.typeChamps["headerProperties"][indexSelect].toString()].indexDataV;
        let libelle = this.typeChamps["headerProperties"][indexSelect + 1].toString();
        let idxNext = this.tabIndicesProp[indexSelect + 1][libelle].indexDataV;

        this.filteredVariantsData[indexSelect + 1] = [];

        let finaltest = this.filteredVariantsList;
        // console.log("filteredVariantsList", this.filteredVariantsList);

        this.tabIdx.push(idx);
        this.variantsChoices.forEach((choice, indexChoice) => {
          if (choice.toString() !== "") {
            finaltest = finaltest.filter(variant => {
              return variant.properties[this.tabIdx[indexSelect]].toString() == this.variantsChoices[indexSelect].toString();
            });
          }
        });
        finaltest.forEach(variant => {
          this.filteredVariantsData[indexSelect + 1].push(variant.properties[idxNext]);
        });

        // suppression des valeurs en doublons
        this.filteredVariantsData[indexSelect + 1] = this.uniq(this.filteredVariantsData[indexSelect + 1]);

        // mise a jour de la liste des variantes
        this.filteredVariantsList = finaltest;
      }
      // vérification de la selection de toutes les options
      this.checkCombiBeforeShowButton();
    },

    resetSelect() {
      this.selectedVariant = [];
      for (let i = 0; i < this.filteredVariantsData.length; i++) {
        this.filteredVariantsData[i] = [];
        Vue.set(this.filteredVariantsData, i, []);
      }

      this.filteredVariantsData[0] = this.initialList;
      for (let i = 0; i < this.variantsChoices.length; i++) {
        this.variantsChoices[i] = [];
        Vue.set(this.variantsChoices, i, []);
      }

      this.filteredVariantsList = this.variantsOriginal;
      this.variantsChoices[0][0] = "";
      this.checkCombiBeforeShowButton();
    },

    checkCombiBeforeShowButton() {
      let limit = this.variantsChoices.length;
      this.variantsChoices.forEach((el, idx) => {
        if (el[0] !== "") {
          limit--;
        }
      });
      if (limit == 0) {
        this.showDeclinedPrices();

        this.showAddCardBtn = true;
      } else {
        this.showAddCardBtn = false;
      }
    },

    showDeclinedPrices() {
      // moulinette pour filtrer le talbeau des déclinaisons avec tous les params des select
      this.selectedVariant = this.filteredVariantsList;

      for (let i = 0; i < this.tabIndicesProp.length; i++) {
        let indexJson = this.tabIndicesProp[i][this.typeChamps["headerProperties"][i].toString()].indexDataV;
        this.selectedVariant = this.selectedVariant.filter(elem => {
          return elem.properties[indexJson] == this.variantsChoices[i];
        });
      }
    },

    onSlideStart(slide) {
      this.sliding = true;
    },

    onSlideEnd(slide) {
      this.sliding = false;
    },

    correctUrl(url) {
      let finalUrl = url;
      let protocolHTTPS = finalUrl.substring(0, 8);
      let protocolHTTP = finalUrl.substring(0, 7);
      let protocolWWW = finalUrl.substring(0, 4);
      if (protocolHTTPS == "https://" || protocolHTTPS == "HTTPS://") {
        return finalUrl;
      }

      if (protocolHTTP == "http://" || protocolHTTP == "HTTP://") {
        return finalUrl;
      }

      if (protocolWWW == "www." || protocolHTTP == "WWW.") {
        return "http://" + finalUrl;
      }
      return "http://www." + finalUrl;
    },

    checkFormValidity() {
      const valid = this.$refs.form.checkValidity();
      this.nameState = valid;
      return valid;
    },

    resetModal() {
      this.name = "";
      this.nameState = null;
    },

    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault();
      // Trigger submit handler
      this.handleSubmit();
    },

    handleSubmit() {
      // Exit when the form isn't valid
      if (!this.checkFormValidity()) {
        return;
      }
      // Push the name to submitted names
      this.submittedNames.push(this.name);
      // Hide the modal manually
      this.$nextTick(() => {
        this.$bvModal.hide("modal-bon-cadeau");
        this.$bvModal.hide("modal-ami");
      });
    },

    onSubmit(evt) {
      evt.preventDefault();
      alert(JSON.stringify(this.form));
    },

    onReset(evt) {
      evt.preventDefault();
      // Reset our form values
      this.form.email = "";
      this.form.name = "";
      this.form.food = null;
      this.form.checked = [];
      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },

    addToCart(productToAdd, variant) {
      this.$store.dispatch("addProductToCart", { product: productToAdd, quantity: 1, variant: variant });
      this.showModalAdd = true;
      this.timerModal("addCart", this.qte);
    },

    timerModal(modalId, modalTimeoutSeconds) {
      let modalSetTimeout = null;
      modalSetTimeout = setTimeout(() => {
        this.$bvModal.hide(modalId);
        this.showModalAdd = false;
      }, modalTimeoutSeconds * 1000);
    }
  }
};
</script>
